<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); 
/**
*
* @version $Id: ems_russia.php 1589 2010-04-17 20:27:20Z a2ller $
* @package VirtueMart
* @subpackage shipping
* @copyright Copyright (C) 2010 a.berezovsky - All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/


/** 
* EMS Post Russia Module
* @copyright (C) 2010 by dev.eska8.com  All rights reserved.
* @author Anatoly Berezovsky - welcome@eska8.com
*/
class ems_russia {

  var $classname = "ems_russia";
  
  /**************************************************************************
  ** name: list_rates($d)
  ** created by: a.berezovsky <welcome@eska8.com>
  ** description:  Get the rate from emspost.ru
  **               
  ** parameters: $Weight - Weight of order
  **             $state - Russian regions id
  **             $country - country ISO_2
  ** returns: the cost to ship this order by EMS Post Russia
  ***************************************************************************/  
  function list_rates( &$d ) {
      require_once(CLASSPATH ."shipping/".$this->classname.".cfg.php");
      global $total, $CURRENCY_DISPLAY,$cart;
      $db = new ps_DB;

      $q = "SELECT country,state,company,first_name,last_name,middle_name,address_1,city,zip FROM #__{vm}_user_info WHERE ";
      $q .= "user_info_id='". $d["ship_to_info_id"] . "'";
      $db->query($q);
      $db->next_record(); 
      $country = $db->f("country");
      $state = $db->f("state");
      $city = $db->f("city");
      $zip = $db->f("zip");      
      $address_1 = $db->f("address_1");
      $first_name = $db->f("first_name");
      $last_name = $db->f("last_name");
      $middle_name = $db->f("middle_name");      
 
      if (!$state){echo "EMS Почта России (сайт: <a href='http://emspost.ru/calc.php'>http://emspost.ru/calc.php</a>): <strong>Не выбран регион доставки. Пожалуйста, заполните все поля в вашем профиле.</strong>"; return false;}
     
      $q2 = "SELECT country_2_code,country_name,country_id FROM #__{vm}_country WHERE country_3_code='$country' ";
      $db->query($q2);
      $db->next_record(); 
      $country = $db->f("country_2_code");
      $country_name = $db->f("country_name");
      $country_id = $db->f("country_id");
      
      $q3 = "SELECT state_name,state_3_code FROM #__{vm}_state WHERE state_2_code='$state' AND country_id='$country_id' ";
      $db->query($q3);
      $db->next_record(); 
      $state_name = $db->f("state_name");
      $state_code = $db->f("state_3_code");

      $Weight = $d['weight'];
      if ($Weight > (int)CONF_EMSPOSTP_MAX_WEIGHT) return false;



	$ch = curl_init();
	$x="country_iso_2=".$country."&zone_code=".$state."&Weight=".$Weight."&total=".$total."&sum=".(int)CONF_EMSPOSTP_SUM."&added=".(int)CONF_EMSPOSTP_ADDED."&csum=".(int)CONF_EMSPOSTP_CSUM;
	curl_setopt($ch, CURLOPT_URL, "http://popchina.ru/callbackhandlers/emspost_handler.php");
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $x);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	$result = curl_exec($ch);
	curl_close($ch);

if ($result==-1) return false; else eval($result);
$rate = $del_cost;


      // THE ORDER OF THOSE VALUES IS IMPORTANT:
      // carrier_name|rate_name|totalshippingcosts|rate_id
      
      $value = urlencode(__CLASS__."|EMS Почта России|".$country_name.", ".$state_name.", ".$city.", ".$zip.", ".$last_name." ".$first_name." ".$middle_name."|".$rate."|".$state);
      
      $_SESSION[$value] = "1";

      $string = "<table width=\"100%\">
<tr class=\"sectiontableheader\"><th>&nbsp;</th><th>Вариант доставки</th><th>Тариф доставки</th><th>Срок доставки, дней</th><th>Вес, кг</th><th>Цена, руб.</th></tr>
<tr class=\"sectiontableentry2\">
<td width=\"10\" align=\"center\"><input type=\"radio\" checked=\"checked\" name=\"shipping_rate_id\" value=\"$value\" />
</td>
<td align=\"center\">
EMS Почта России
</td>
<td align=\"center\">
".$state_name."
</td>
<td align=\"center\">
".$min."
</td>
<td align=\"center\">
".$Weight."
</td>
<td align=\"center\">
<strong>". $CURRENCY_DISPLAY->getFullValue($rate )."</strong>
</td>
</tr>
</table>";
      
      echo $string;

    }
    
  function get_rate( &$d ) {

          $shipping_rate_id = $_REQUEST["shipping_rate_id"];
          $zone_arr = explode("|", urldecode(urldecode($shipping_rate_id)) );
          $order_shipping = $zone_arr[3];

          return $order_shipping;
  }

  function get_tax_rate( $zone_id=0 ) {
      return 0;
  }

        /**
    * Validate this Shipping method by checking if the SESSION contains the key
    * @returns boolean False when the Shipping method is not in the SESSION
    */
        function validate( $d ) {
          $shipping_rate_id = $_REQUEST["shipping_rate_id"];

          if( array_key_exists( $shipping_rate_id, $_SESSION ))
                return true;
          else
                return false;
        }
	/**
    * Show all configuration parameters for this Shipping method
    * @returns boolean False when the Shipping method has no configration
    */
	function show_configuration() {
		global $VM_LANG;
		/** Read current Configuration ***/
		require_once(CLASSPATH ."shipping/".$this->classname.".cfg.php");
    ?>
      <table>
    <tr>
        <td><strong>Введите максимально-возможный к отправке вес посылки:</strong></td>
		<td>
            <input type="text" name="CONF_EMSPOSTP_MAX_WEIGHT" class="inputbox" value="<?php echo CONF_EMSPOSTP_MAX_WEIGHT ?>" />
		</td>
		<td>
        <?php echo mm_ToolTip("вес посылки в кг") ?> 
        </td>
    </tr>
    <tr>
        <td><strong>Добавить сумму к стоимости доставки:</strong></td>
		<td>
            <input type="text" name="CONF_EMSPOSTP_SUM" class="inputbox" value="<?php echo CONF_EMSPOSTP_SUM ?>" />
		</td>
		<td>
        <?php echo mm_ToolTip("Введите число. Например, если вы хотите добавить 10руб. - укажите число 10.") ?> 
        </td>
    </tr>
    <tr>
        <td><strong>Рассчитывать обьявленную ценность:</strong></td>
		<td>
            <input type="text" name="CONF_EMSPOSTP_ADDED" class="checkbox" value="<?php echo CONF_EMSPOSTP_ADDED ?>" />
		</td>
		<td>
        <?php echo mm_ToolTip("Укажите 1 для рассчёта объявленной ценности.") ?> 
        </td>
    </tr>
    <tr>
        <td><strong>Добавить сумму за вывоз 1кг товара из Китая:</strong></td>
		<td>
            <input type="text" name="CONF_EMSPOSTP_CSUM" class="inputbox" value="<?php echo CONF_EMSPOSTP_CSUM ?>" />
		</td>
		<td>
        <?php echo mm_ToolTip("Введите число. Например, если вы хотите добавить 10руб. - укажите число 10.") ?> 
        </td>
    </tr>
	</table>
   <?php
   // return false if there's no configuration
   return true;
	}
	/**
  * Returns the "is_writeable" status of the configuration file
  * @param void
  * @returns boolean True when the configuration file is writeable, false when not
  */
	function configfile_writeable() {
		return is_writeable( CLASSPATH."shipping/".$this->classname.".cfg.php" );
	}

	/**
	* Writes the configuration file for this shipping method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
	function write_configuration( &$d ) {
	    global $vmLogger;

		$my_config_array = array("CONF_EMSPOSTP_MAX_WEIGHT" => $d['CONF_EMSPOSTP_MAX_WEIGHT'],"CONF_EMSPOSTP_ADDED" => $d['CONF_EMSPOSTP_ADDED'], "CONF_EMSPOSTP_SUM" => $d['CONF_EMSPOSTP_SUM'], "CONF_EMSPOSTP_СSUM" => $d['CONF_EMSPOSTP_СSUM']);
		$config = "<?php\n";
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
		foreach( $my_config_array as $key => $value ) {
			$value = str_replace('\'', '\\\'', $value );
			$config .= "define ('$key', '$value');\n";
		}

		$config .= "?>";

		if ($fp = fopen(CLASSPATH ."shipping/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
			return true;
		}
		else {
			$vmLogger->err( "Error writing to configuration file" );
			return false;
		}
	}

}
?>